#!/usr/bin/perl
$mode=0;

sub pax {
 my ($l)=@_;
 if ($l eq '') {
  return "";
 }
 if ($mode==0 && $l=~/^((
   ([a-zA-Z_][a-zA-Z0-9_]*\**\s+[\*\s]*)+)
   ([a-zA-Z_][a-zA-Z0-9_]*)\s*
   (\([^\)]*\)))
   \s*([;{])(.*)$/x) {
  if ($6 eq '{') { 
   return $1.";\n".pax($7);;
  } else {
   return "//[WARNING]: declaration without body!)\n".
          $1.";\n".pax($7);;
  } 
 }
 if ($mode==0 && $l=~/^\s*\/\/\[HEADER\](.*)$/) {
  return "$1\n";
 }
 if ($mode==0 && $l=~/^(.*)\/\/\[PASS\]\s*$/) {
  return "$1\n";
 }
 if ($mode==0 && $l=~/^\s*([^=]*)(=[^\/]+)?\s*;\s*(\/\/.*)\[EXT\]\s*/) {
  $s2=$2;
  if (!($s2 eq '')) {
   $s2="($s2)";
  }
  return "extern $1;$3$s2\n";
 }
 if ($mode==0 && $l=~/(\/\*\*.*\*\/)(.*)$/) {
  return "$1\n".pax($2);
 } elsif ($mode==0 && $l=~/(\/\*\*($|[^\/].*))/) {
  $mode=1;
  return "$1\n";
 } elsif ($mode==1 && $l=~/^(.*\*\/)(.*)$/) {
  $mode=0;
  return "$1\n".pax($2);
 } elsif ($mode==1) {
  return "$l\n";
 }
 return "";
}

sub headers {
 ($infile,$in2file,$outfile)=@_;
 if ($outfile eq '') { die "no dest specified!";}
 if ($infile eq $outfile) { die "(source=dest)=error!";}
 if ($in2file eq $outfile) { die "(source2=dest)=error!";}
 $guard=$outfile;
 $guard=~s/\./_/g;
 $guard=uc("__${guard}__");
 $all="";
 #read in
 $all.="/*** Automatically generated file from $in2file and $infile.\nDo not modify, modify original files instead */\n";
 $all.="#ifndef $guard //include only once\n#define $guard\n";
 open(IN, "<$in2file");
 while(<IN>) {
  $all.=$_;
 }
 close(IN);
 $all.="\n"; #newline tu byt musi ....
 #read in 2
 open(IN, "<$infile");
 while(<IN>) {
  s/[\r\n]//g;
  $all.=pax($_);
 }
 close(IN);
 $all.="#endif // of $guard\n";
 if ($all eq '' ) {die "File is empty or file read error ?!";}
 #write out
 open(OUT,">$outfile");
 print OUT $all;
 close(OUT);
}

$sources=<<EOF;
cfg_file
util
buffer
net
EOF

%opt=();@arg=();$argc=0;
for ($i=0;$i<@ARGV;$i++) {
 $_=$ARGV[$i];
 if (/^-(.*)/) {
  $opt{$1}=1;
 } else {
  $arg[@arg]=$_;
  $argc++;
 }
}
if ($argc) {
 $sources=join(" ",@arg);
}
if ($opt{'help'} || $opt{'-help'} || $opt{'h'} || $opt{'?'}) {
 print <<EOF;
Usage: $0 [-q] [fn ...]
-q\tquiet mode
fn\tnames of source files
EOF
 exit(0);
}

@src=split(/[\n,]/,$sources);
for ($i=0;$i<@src;$i++) {
 $n=$src[$i];
 $n=~s/\..*$//;
 $in="${n}.c";
 $in2="${n}.h.h";
 $out="${n}.h";
 if (!$opt{'q'}) {
  print "[$i] $in + $in2 -> $out\n";
 }
 headers($in,$in2,$out);
}
