use strict;

my $maincomment='';
my $debug=0;
my $warn=1;

my $mode='';my $cmt='';my $lcmt='';my $tcmt='';my $wcmt='';my $cfunc='';

my $filename=$ARGV[0];
$filename=~s/^..[\/\\]//g;
$filename=~s/[\/\\]/_/g;
my $qote=0; #uroven zavorek

my $undoc='<font color=red>UNDOCUMENTED!</font>';
my $out='';

sub save {
 my ($s,$name)=@_;
 open(D, ">>".$name) || return 0;
 print D $s;
 close D ||return 0;
 return 1;
}

sub trim {
 my ($c)=@_;
 $c=~s/^\s+//;
 $c=~s/\s+$//;
 $c=~s/[\r\n]+$//;
 return $c;
}

sub out { #type:filename:identifier:data.....
 my @a=@_;
 my $l=0;
 my $r='';
 while ($l<@a) {
  if ($l>0) {$r.=":";}
  $r.=qot(trim($a[$l]));
  $l++;
 }
 $out.="$r\n";
}

sub lcomment {
 # TODO: mel by rozeznavat i radkovekomentare zacinajici na stejne radce
 # a sam si pritahnout dalsi data
 my ($i)=@_;
 if ($i=~/(.*?)\/\/(.*)$/) {
  return (trim($1),trim($2))
 } else {
  return ($i,'');
 }
}
sub qot {
 my ($l)=@_;
 $l=~s/:/&#58;/g;
 return $l;
}

sub warning {
 my ($l)=@_;
 if ($warn) {print "WARNING: $l\n";}
}

sub var_out {
 my ($what,$typ,$cmt)=@_;
 while ($what=~/\{.*,.*\}/g) {
  $what=~s/(\{.*),(.*\})/$1&#44;$2/g;
  print "$what\n";
 }
 my @wh=split(/,/,$what);
 for(my $i=0;$i<@wh;$i++) {
  my $t=$typ;
  my $varname=trim($wh[$i]);
  my $iv='?';
  if ($varname=~/^\*\s*(.*)$/) {
   $varname=$1;
   $t='*'.$t;
  }
  while ($varname=~/^(.*?)\[([^\]]+)\](.*)$/) {
   $varname=$1.$3;
   $t=$t.'['.$2.']';
  }
  if ($varname=~/^(.*)=(.*)$/) {
   $varname=$1;
   $iv=$2;
  }
  out('var',$filename,$varname."<!--$filename-->",$t,$iv,$cmt);
 }
}
my $todocnt=0;

open(D, "<".$ARGV[0]) || print STDERR "File not found: $ARGV[0]\n";
while (<D>) {
begin:
 $_=trim($_);
 if (/^$/) {   #line empty
  goto cont;
 }
# print ("LINE: <<$_>> MODE=$mode\n");
 if (/(.*?)\/\/\s*(TODO.*)/) {
  $_=$1;
  out('todo',$filename,$cfunc."<!--$todocnt($filename)-->",$2);
  $todocnt++;
 }
 if ($mode eq 'comment') {
  if (/^(.*?)\*\/(.*)$/) {
   my $r=$2;
   if ($1=~/(.*?)(todo)(.*)/i) {
    my $tcmt.="$2$3<br>";
   }
   $cmt.="<br>".$1;
   $mode='';
   $_=$r;
   goto begin;
  } else {
   $cmt.="<br>".$_;
  }
 } elsif ($mode eq 'xcomment') {
  if (/^(.*?)\*\/(.*)$/) {
   $wcmt.=" ".$1;
   warning("found /* $wcmt */");
   $wcmt='';
   $mode='';
   $_=$2;
   goto begin;
  } else {
   $wcmt.=" ".$_;
  }
 } elsif ($mode eq 'maincomment') {
  if (/^(.*?)\*\/(.*)$/) {
   $maincomment.=" ".$1;
   $mode='';
   $_=$2;
   goto begin;
  } else {
   $maincomment.=" ".$_;
  }
 } else {
  if (/^\/\/(.*)$/) {
   if ($1=~/(.*?)(todo)(.*)/i) {
    my $tcmt.="$2$3<br>";
   }
   if (!(trim($1) eq '')){
    $lcmt.=$1.'<br>';
    warning("found //$1");
   }
  } elsif (/^\#define\s+([a-zA-Z_][a-zA-Z_0-9]*)\s+(.*)$/) {
   my $name=$1;
   my $val=$2;
   my $cm='';
   ($val,$cm)=lcomment($val);
   if ($cm eq '') {$cm=$undoc;}
   out('const',$filename,$name."<!--$filename-->",$val,$cm)
   # konstanta
  } elsif (/^\#define\s+([a-zA-Z_][a-zA-Z_0-9]*)\s*(\/\/.*)?$/) {
   # neskodny define - lze ignorovat
  } elsif (/^typedef\s*(.*)$/) {
   my $li=$1;
   my $tcmt='';
   if ($li=~/\/\/\s*(.*)/) { # //komentar
    $tcmt.=$1;
    $li=~s/\/\/.*//;
   }
   while (!($li=~/[{;]/)) { # fetchujeme data az k prvni zavorce { nebo stredniku ;
    $li.=<D>;
    if ($li=~/\/\/\s*(.*)/) { # //komentar
     $tcmt.=$1;
     $li=~s/\/\/.*//;
    }
   }
   $li=~s/\s+/ /g;
   if (!($li=~/{/)) { # neco co konci strednikem - kratky typedef
    if ($li=~/^(([a-zA-Z_][a-zA-Z_0-9]*\s+)+)([a-zA-Z_][a-zA-Z_0-9]*)\s*(\[[a-zA-Z_0-9]*\])?\s*;/) {
     if ($tcmt eq '') {$tcmt=$undoc;}
     out('type',$filename,$3."<!--$filename-->","$1$4",$tcmt);
    } else {
     warning("malformed short typedef $li //$tcmt");
    }
   } elsif ($li=~/\s*enum\s*([a-zA-Z_][a-zA-Z_0-9]*)?\s*{/) {
    warning ("unknown partial typedef enum $li"); 
   } else {
    warning ("unknown partial typedef $li");
   }
   # warning("partial typedef $li");
   #TODO:read typedef
  } elsif (/^enum(.*)$/) {
   warning("partial enum $1");
   #TODO:read enum
  } elsif (/^(
   ([a-zA-Z_][a-zA-Z0-9_]*\**\s+)+   [\*\s]*)
   ([a-zA-Z_][a-zA-Z0-9_]*)\s*
   (\([^\)]*\))
   \s*;(.*)$/x) {
   #deklarace bez tela se ignoruji
   $_=$5;
   goto begin;
  } elsif (($qote==0) and (/^(
   ([a-zA-Z_][a-zA-Z0-9_]*\**\s+)+    [\*\s]*)
   ([a-zA-Z_][a-zA-Z0-9_]*)\s*
   (\([^\)]*\))
   \s*{(.*)$/x)) {
   $cfunc=$3;
   if (!($tcmt eq '')) { #nejaky to-do comment z minula
    out('todo',$filename,$cfunc."?<!--$todocnt($filename)-->",$tcmt);
    $todocnt++;
    $tcmt='';
   }
   if ($cmt eq '') { $cmt=$undoc; }
   out('function',$filename,$3."<!--$filename-->",$4,$1,$cmt);
   $cmt='';
   $qote=1;
   $_=$5;
   goto begin;
  } elsif (/^\/\*\*\*(.*)$/) { #/*** comment
   if ($1=~/^(.*)\*\/(.*)$/) {
    $maincomment.=$1;
    $_=$2;
    goto begin;
   } else {
    $mode='maincomment';
    $maincomment.=$1;
   }
  } elsif (/^\/\*\*(.*)$/) { #/** comment
   if ($1=~/^(.*)\*\/(.*)$/) {
    $cmt=$1;
    $_=$2;
    goto begin;
   } else {
    $mode='comment';
    $cmt=$1;
   }
  } elsif (/^\/\*(.*)$/) { #nezajimavy comment /*
   if ($1=~/^(.*)\*\/(.*)$/) {
    $_=$2;
    goto begin;
   } else {
    $mode='xcomment';
   }
  # lokalni promenne se nedokumentuji
  } elsif (($qote==0) and (/^
   (
    (unsigned\s+|signed\s+)*
    ([a-zA-Z_][a-zA-Z0-9_]+)
   )\s+
   (         \**\s*[a-zA-Z_][a-zA-Z0-9_]*   (\[[a-zA-Z0-9_\*]*\])* (=[\.\-0-9a-zA-Z_\*]+|=\{[\-\.,0-9a-zA-Z_\*]+\})?
     \s*(,\s*\**\s*[a-zA-Z_][a-zA-Z0-9_]*   (\[[a-zA-Z0-9_\*]*\])* (=[\.\-0-9a-zA-Z_\*]+|=\{[\-\.,0-9a-zA-Z_\*]+\})?
        )*
   );
  (.*)$/x)) {# variable
   my $what=$4;
   my $typ=$1;
   my $ct=trim($10);
   my ($tr,$cmt)=lcomment($ct);
   if ($cmt eq '') {$cmt=$undoc;}
   if (!($tr eq '')) {warning('Trash between $what and comment');}
   var_out($what,$typ,$cmt);
  } elsif (/^\#(include|ifdef|endif|ifndef|else|undef)(.*)$/) { #preprocesor
   # ignore, but maybe use ifdef/endif
  } else {
   if ($qote>0) { #nejaky chrchel kodu
    my $c;
    ($_,$c)=lcomment($_);   
    if (!($c eq '')) {
     if ($debug) {print ("Found line comment: $c\n");}
     if ($c=~/(TODO)(.*)/i) {
      my $r="$1$2";
      if (!($c eq '')) {
       $r.="(<b>$_</b>)";
      }  
      out('todo',$filename,$cfunc."<!--$todocnt($filename)-->",$r);
      $todocnt++;
     }
    }
    if ($debug) {print "> $qote $_\n";}
    #todo: nejdriv najit retezce, v tech muzou bejt taky zavorky
    while (/\{[^\"\']*\}/) {
     s/\{[^\"\']*\}//;
    }
    while (/\{/) {
     s/\{//;
     $qote++;
    }
    while (/\}/) {
     s/\}//;
     $qote--;
    }
   } else {
    print "unrecognized $_\n";
   }
   if ($qote==0) {
    $cfunc='';
   }
  }
 }

cont:
} 
if ($maincomment=~/./) {out("maincomment",$filename,$maincomment);}
close(D);
save($out,$ARGV[1]);
